"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ora;
exports.oraPromise = oraPromise;

var _nodeProcess = _interopRequireDefault(require("process"));

var _nodeReadline = _interopRequireDefault(require("readline"));

var _chalk = _interopRequireDefault(require("chalk"));

var _cliCursor = _interopRequireDefault(require("cli-cursor"));

var _cliSpinners = _interopRequireDefault(require("cli-spinners"));

var _logSymbols = _interopRequireDefault(require("log-symbols"));

var _stripAnsi = _interopRequireDefault(require("strip-ansi"));

var _wcwidth = _interopRequireDefault(require("wcwidth"));

var _isInteractive = _interopRequireDefault(require("is-interactive"));

var _isUnicodeSupported = _interopRequireDefault(require("is-unicode-supported"));

var _bl = require("bl");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var TEXT = Symbol('text');
var PREFIX_TEXT = Symbol('prefixText');
var ASCII_ETX_CODE = 0x03; // Ctrl+C emits this code
// TODO: Use class fields when ESLint 8 is out.

var StdinDiscarder = /*#__PURE__*/function () {
  function StdinDiscarder() {
    _classCallCheck(this, StdinDiscarder);

    this.requests = 0;
    this.mutedStream = new _bl.BufferListStream();
    this.mutedStream.pipe(_nodeProcess["default"].stdout);
    var self = this; // eslint-disable-line unicorn/no-this-assignment

    this.ourEmit = function (event, data) {
      var stdin = _nodeProcess["default"].stdin;

      for (var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
        args[_key - 2] = arguments[_key];
      }

      if (self.requests > 0 || stdin.emit === self.ourEmit) {
        if (event === 'keypress') {
          // Fixes readline behavior
          return;
        }

        if (event === 'data' && data.includes(ASCII_ETX_CODE)) {
          _nodeProcess["default"].emit('SIGINT');
        }

        Reflect.apply(self.oldEmit, this, [event, data].concat(args));
      } else {
        Reflect.apply(_nodeProcess["default"].stdin.emit, this, [event, data].concat(args));
      }
    };
  }

  _createClass(StdinDiscarder, [{
    key: "start",
    value: function start() {
      this.requests++;

      if (this.requests === 1) {
        this.realStart();
      }
    }
  }, {
    key: "stop",
    value: function stop() {
      if (this.requests <= 0) {
        throw new Error('`stop` called more times than `start`');
      }

      this.requests--;

      if (this.requests === 0) {
        this.realStop();
      }
    }
  }, {
    key: "realStart",
    value: function realStart() {
      var _this = this;

      // No known way to make it work reliably on Windows
      if (_nodeProcess["default"].platform === 'win32') {
        return;
      }

      this.rl = _nodeReadline["default"].createInterface({
        input: _nodeProcess["default"].stdin,
        output: this.mutedStream
      });
      this.rl.on('SIGINT', function () {
        if (_nodeProcess["default"].listenerCount('SIGINT') === 0) {
          _nodeProcess["default"].emit('SIGINT');
        } else {
          _this.rl.close();

          _nodeProcess["default"].kill(_nodeProcess["default"].pid, 'SIGINT');
        }
      });
    }
  }, {
    key: "realStop",
    value: function realStop() {
      if (_nodeProcess["default"].platform === 'win32') {
        return;
      }

      this.rl.close();
      this.rl = undefined;
    }
  }]);

  return StdinDiscarder;
}();

var stdinDiscarder;

var Ora = /*#__PURE__*/function () {
  function Ora(options) {
    _classCallCheck(this, Ora);

    if (!stdinDiscarder) {
      stdinDiscarder = new StdinDiscarder();
    }

    if (typeof options === 'string') {
      options = {
        text: options
      };
    }

    this.options = _objectSpread({
      text: '',
      color: 'cyan',
      stream: _nodeProcess["default"].stderr,
      discardStdin: true
    }, options);
    this.spinner = this.options.spinner;
    this.color = this.options.color;
    this.hideCursor = this.options.hideCursor !== false;
    this.interval = this.options.interval || this.spinner.interval || 100;
    this.stream = this.options.stream;
    this.id = undefined;
    this.isEnabled = typeof this.options.isEnabled === 'boolean' ? this.options.isEnabled : (0, _isInteractive["default"])({
      stream: this.stream
    });
    this.isSilent = typeof this.options.isSilent === 'boolean' ? this.options.isSilent : false; // Set *after* `this.stream`

    this.text = this.options.text;
    this.prefixText = this.options.prefixText;
    this.linesToClear = 0;
    this.indent = this.options.indent;
    this.discardStdin = this.options.discardStdin;
    this.isDiscardingStdin = false;
  }

  _createClass(Ora, [{
    key: "_updateInterval",
    value: function _updateInterval(interval) {
      if (interval !== undefined) {
        this.interval = interval;
      }
    }
  }, {
    key: "getFullPrefixText",
    value: function getFullPrefixText() {
      var prefixText = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this[PREFIX_TEXT];
      var postfix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ' ';

      if (typeof prefixText === 'string') {
        return prefixText + postfix;
      }

      if (typeof prefixText === 'function') {
        return prefixText() + postfix;
      }

      return '';
    }
  }, {
    key: "updateLineCount",
    value: function updateLineCount() {
      var columns = this.stream.columns || 80;
      var fullPrefixText = this.getFullPrefixText(this.prefixText, '-');
      this.lineCount = 0;

      var _iterator = _createForOfIteratorHelper((0, _stripAnsi["default"])(' '.repeat(this.indent) + fullPrefixText + '--' + this[TEXT]).split('\n')),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var line = _step.value;
          this.lineCount += Math.max(1, Math.ceil((0, _wcwidth["default"])(line) / columns));
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
    }
  }, {
    key: "frame",
    value: function frame() {
      var frames = this.spinner.frames;
      var frame = frames[this.frameIndex];

      if (this.color) {
        frame = _chalk["default"][this.color](frame);
      }

      this.frameIndex = ++this.frameIndex % frames.length;
      var fullPrefixText = typeof this.prefixText === 'string' && this.prefixText !== '' ? this.prefixText + ' ' : '';
      var fullText = typeof this.text === 'string' ? ' ' + this.text : '';
      return fullPrefixText + frame + fullText;
    }
  }, {
    key: "clear",
    value: function clear() {
      if (!this.isEnabled || !this.stream.isTTY) {
        return this;
      }

      this.stream.cursorTo(0);

      for (var index = 0; index < this.linesToClear; index++) {
        if (index > 0) {
          this.stream.moveCursor(0, -1);
        }

        this.stream.clearLine(1);
      }

      if (this.indent || this.lastIndent !== this.indent) {
        this.stream.cursorTo(this.indent);
      }

      this.lastIndent = this.indent;
      this.linesToClear = 0;
      return this;
    }
  }, {
    key: "render",
    value: function render() {
      if (this.isSilent) {
        return this;
      }

      this.clear();
      this.stream.write(this.frame());
      this.linesToClear = this.lineCount;
      return this;
    }
  }, {
    key: "start",
    value: function start(text) {
      if (text) {
        this.text = text;
      }

      if (this.isSilent) {
        return this;
      }

      if (!this.isEnabled) {
        if (this.text) {
          this.stream.write("- ".concat(this.text, "\n"));
        }

        return this;
      }

      if (this.isSpinning) {
        return this;
      }

      if (this.hideCursor) {
        _cliCursor["default"].hide(this.stream);
      }

      if (this.discardStdin && _nodeProcess["default"].stdin.isTTY) {
        this.isDiscardingStdin = true;
        stdinDiscarder.start();
      }

      this.render();
      this.id = setInterval(this.render.bind(this), this.interval);
      return this;
    }
  }, {
    key: "stop",
    value: function stop() {
      if (!this.isEnabled) {
        return this;
      }

      clearInterval(this.id);
      this.id = undefined;
      this.frameIndex = 0;
      this.clear();

      if (this.hideCursor) {
        _cliCursor["default"].show(this.stream);
      }

      if (this.discardStdin && _nodeProcess["default"].stdin.isTTY && this.isDiscardingStdin) {
        stdinDiscarder.stop();
        this.isDiscardingStdin = false;
      }

      return this;
    }
  }, {
    key: "succeed",
    value: function succeed(text) {
      return this.stopAndPersist({
        symbol: _logSymbols["default"].success,
        text: text
      });
    }
  }, {
    key: "fail",
    value: function fail(text) {
      return this.stopAndPersist({
        symbol: _logSymbols["default"].error,
        text: text
      });
    }
  }, {
    key: "warn",
    value: function warn(text) {
      return this.stopAndPersist({
        symbol: _logSymbols["default"].warning,
        text: text
      });
    }
  }, {
    key: "info",
    value: function info(text) {
      return this.stopAndPersist({
        symbol: _logSymbols["default"].info,
        text: text
      });
    }
  }, {
    key: "stopAndPersist",
    value: function stopAndPersist() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (this.isSilent) {
        return this;
      }

      var prefixText = options.prefixText || this.prefixText;
      var text = options.text || this.text;
      var fullText = typeof text === 'string' ? ' ' + text : '';
      this.stop();
      this.stream.write("".concat(this.getFullPrefixText(prefixText, ' ')).concat(options.symbol || ' ').concat(fullText, "\n"));
      return this;
    }
  }, {
    key: "indent",
    get: function get() {
      return this._indent;
    },
    set: function set() {
      var indent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;

      if (!(indent >= 0 && Number.isInteger(indent))) {
        throw new Error('The `indent` option must be an integer from 0 and up');
      }

      this._indent = indent;
      this.updateLineCount();
    }
  }, {
    key: "spinner",
    get: function get() {
      return this._spinner;
    },
    set: function set(spinner) {
      this.frameIndex = 0;

      if (_typeof(spinner) === 'object') {
        if (spinner.frames === undefined) {
          throw new Error('The given spinner must have a `frames` property');
        }

        this._spinner = spinner;
      } else if (!(0, _isUnicodeSupported["default"])()) {
        this._spinner = _cliSpinners["default"].line;
      } else if (spinner === undefined) {
        // Set default spinner
        this._spinner = _cliSpinners["default"].dots;
      } else if (spinner !== 'default' && _cliSpinners["default"][spinner]) {
        this._spinner = _cliSpinners["default"][spinner];
      } else {
        throw new Error("There is no built-in spinner named '".concat(spinner, "'. See https://github.com/sindresorhus/cli-spinners/blob/main/spinners.json for a full list."));
      }

      this._updateInterval(this._spinner.interval);
    }
  }, {
    key: "text",
    get: function get() {
      return this[TEXT];
    },
    set: function set(value) {
      this[TEXT] = value;
      this.updateLineCount();
    }
  }, {
    key: "prefixText",
    get: function get() {
      return this[PREFIX_TEXT];
    },
    set: function set(value) {
      this[PREFIX_TEXT] = value;
      this.updateLineCount();
    }
  }, {
    key: "isSpinning",
    get: function get() {
      return this.id !== undefined;
    }
  }, {
    key: "isEnabled",
    get: function get() {
      return this._isEnabled && !this.isSilent;
    },
    set: function set(value) {
      if (typeof value !== 'boolean') {
        throw new TypeError('The `isEnabled` option must be a boolean');
      }

      this._isEnabled = value;
    }
  }, {
    key: "isSilent",
    get: function get() {
      return this._isSilent;
    },
    set: function set(value) {
      if (typeof value !== 'boolean') {
        throw new TypeError('The `isSilent` option must be a boolean');
      }

      this._isSilent = value;
    }
  }]);

  return Ora;
}();

function ora(options) {
  return new Ora(options);
}

function oraPromise(_x, _x2) {
  return _oraPromise.apply(this, arguments);
}

function _oraPromise() {
  _oraPromise = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(action, options) {
    var actionIsFunction, actionIsPromise, _ref, successText, failText, spinner, promise, result;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            actionIsFunction = typeof action === 'function'; // eslint-disable-next-line promise/prefer-await-to-then

            actionIsPromise = typeof action.then === 'function';

            if (!(!actionIsFunction && !actionIsPromise)) {
              _context.next = 4;
              break;
            }

            throw new TypeError('Parameter `action` must be a Function or a Promise');

          case 4:
            _ref = _typeof(options) === 'object' ? options : {
              successText: undefined,
              failText: undefined
            }, successText = _ref.successText, failText = _ref.failText;
            spinner = ora(options).start();
            _context.prev = 6;
            promise = actionIsFunction ? action(spinner) : action;
            _context.next = 10;
            return promise;

          case 10:
            result = _context.sent;
            spinner.succeed(successText === undefined ? undefined : typeof successText === 'string' ? successText : successText(result));
            return _context.abrupt("return", result);

          case 15:
            _context.prev = 15;
            _context.t0 = _context["catch"](6);
            spinner.fail(failText === undefined ? undefined : typeof failText === 'string' ? failText : failText(_context.t0));
            throw _context.t0;

          case 19:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[6, 15]]);
  }));
  return _oraPromise.apply(this, arguments);
}
