"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var rxjs_1 = require("rxjs");
var observable_1 = require("rxjs/internal/symbol/observable");
var interop_helper_1 = require("./interop-helper");
describe('interop helper', function () {
    it('should simulate interop observables', function () {
        var observable = (0, interop_helper_1.asInteropObservable)((0, rxjs_1.of)(42));
        (0, chai_1.expect)(observable).to.not.be.instanceOf(rxjs_1.Observable);
        (0, chai_1.expect)(observable[observable_1.observable]).to.be.a('function');
    });
    it('should simulate interop subscribers', function () {
        var subscriber = (0, interop_helper_1.asInteropSubscriber)(new rxjs_1.Subscriber());
        (0, chai_1.expect)(subscriber).to.not.be.instanceOf(rxjs_1.Subscriber);
    });
});
//# sourceMappingURL=interop-helper-spec.js.map