"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var index = require("../src/index");
var chai_1 = require("chai");
describe('index', function () {
    it('should export Observable', function () {
        (0, chai_1.expect)(index.Observable).to.exist;
        (0, chai_1.expect)(index.ConnectableObservable).to.exist;
        var operator;
    });
    it('should export the Subject types', function () {
        (0, chai_1.expect)(index.Subject).to.exist;
        (0, chai_1.expect)(index.BehaviorSubject).to.exist;
        (0, chai_1.expect)(index.ReplaySubject).to.exist;
        (0, chai_1.expect)(index.AsyncSubject).to.exist;
    });
    it('should export the schedulers', function () {
        (0, chai_1.expect)(index.asapScheduler).to.exist;
        (0, chai_1.expect)(index.asyncScheduler).to.exist;
        (0, chai_1.expect)(index.queueScheduler).to.exist;
        (0, chai_1.expect)(index.animationFrameScheduler).to.exist;
        (0, chai_1.expect)(index.VirtualTimeScheduler).to.exist;
        (0, chai_1.expect)(index.VirtualAction).to.exist;
    });
    it('should export Subscription', function () {
        (0, chai_1.expect)(index.Subscription).to.exist;
        (0, chai_1.expect)(index.Subscriber).to.exist;
    });
    it('should export Notification', function () {
        (0, chai_1.expect)(index.Notification).to.exist;
    });
    it('should export the appropriate utilities', function () {
        (0, chai_1.expect)(index.pipe).to.exist;
        (0, chai_1.expect)(index.noop).to.exist;
        (0, chai_1.expect)(index.identity).to.exist;
    });
    it('should export error types', function () {
        (0, chai_1.expect)(index.ArgumentOutOfRangeError).to.exist;
        (0, chai_1.expect)(index.EmptyError).to.exist;
        (0, chai_1.expect)(index.ObjectUnsubscribedError).to.exist;
        (0, chai_1.expect)(index.UnsubscriptionError).to.exist;
        (0, chai_1.expect)(index.TimeoutError).to.exist;
    });
    it('should export constants', function () {
        (0, chai_1.expect)(index.EMPTY).to.exist;
        (0, chai_1.expect)(index.NEVER).to.exist;
    });
    it('should export static observable creator functions', function () {
        (0, chai_1.expect)(index.bindCallback).to.exist;
        (0, chai_1.expect)(index.bindNodeCallback).to.exist;
        (0, chai_1.expect)(index.combineLatest).to.exist;
        (0, chai_1.expect)(index.concat).to.exist;
        (0, chai_1.expect)(index.defer).to.exist;
        (0, chai_1.expect)(index.empty).to.exist;
        (0, chai_1.expect)(index.forkJoin).to.exist;
        (0, chai_1.expect)(index.from).to.exist;
        (0, chai_1.expect)(index.fromEvent).to.exist;
        (0, chai_1.expect)(index.fromEventPattern).to.exist;
        (0, chai_1.expect)(index.generate).to.exist;
        (0, chai_1.expect)(index.iif).to.exist;
        (0, chai_1.expect)(index.interval).to.exist;
        (0, chai_1.expect)(index.merge).to.exist;
        (0, chai_1.expect)(index.of).to.exist;
        (0, chai_1.expect)(index.onErrorResumeNext).to.exist;
        (0, chai_1.expect)(index.pairs).to.exist;
        (0, chai_1.expect)(index.race).to.exist;
        (0, chai_1.expect)(index.range).to.exist;
        (0, chai_1.expect)(index.throwError).to.exist;
        (0, chai_1.expect)(index.timer).to.exist;
        (0, chai_1.expect)(index.using).to.exist;
        (0, chai_1.expect)(index.zip).to.exist;
    });
    it('should export all of the operators', function () {
        (0, chai_1.expect)(index.audit).to.exist;
        (0, chai_1.expect)(index.auditTime).to.exist;
        (0, chai_1.expect)(index.buffer).to.exist;
        (0, chai_1.expect)(index.bufferCount).to.exist;
        (0, chai_1.expect)(index.bufferTime).to.exist;
        (0, chai_1.expect)(index.bufferToggle).to.exist;
        (0, chai_1.expect)(index.bufferWhen).to.exist;
        (0, chai_1.expect)(index.catchError).to.exist;
        (0, chai_1.expect)(index.combineAll).to.exist;
        (0, chai_1.expect)(index.combineLatestAll).to.exist;
        (0, chai_1.expect)(index.combineLatestWith).to.exist;
        (0, chai_1.expect)(index.concatAll).to.exist;
        (0, chai_1.expect)(index.concatMap).to.exist;
        (0, chai_1.expect)(index.concatMapTo).to.exist;
        (0, chai_1.expect)(index.concatWith).to.exist;
        (0, chai_1.expect)(index.connect).to.exist;
        (0, chai_1.expect)(index.count).to.exist;
        (0, chai_1.expect)(index.debounce).to.exist;
        (0, chai_1.expect)(index.debounceTime).to.exist;
        (0, chai_1.expect)(index.defaultIfEmpty).to.exist;
        (0, chai_1.expect)(index.delay).to.exist;
        (0, chai_1.expect)(index.delayWhen).to.exist;
        (0, chai_1.expect)(index.dematerialize).to.exist;
        (0, chai_1.expect)(index.distinct).to.exist;
        (0, chai_1.expect)(index.distinctUntilChanged).to.exist;
        (0, chai_1.expect)(index.distinctUntilKeyChanged).to.exist;
        (0, chai_1.expect)(index.elementAt).to.exist;
        (0, chai_1.expect)(index.endWith).to.exist;
        (0, chai_1.expect)(index.every).to.exist;
        (0, chai_1.expect)(index.exhaust).to.exist;
        (0, chai_1.expect)(index.exhaustAll).to.exist;
        (0, chai_1.expect)(index.exhaustMap).to.exist;
        (0, chai_1.expect)(index.expand).to.exist;
        (0, chai_1.expect)(index.filter).to.exist;
        (0, chai_1.expect)(index.finalize).to.exist;
        (0, chai_1.expect)(index.find).to.exist;
        (0, chai_1.expect)(index.findIndex).to.exist;
        (0, chai_1.expect)(index.first).to.exist;
        (0, chai_1.expect)(index.groupBy).to.exist;
        (0, chai_1.expect)(index.ignoreElements).to.exist;
        (0, chai_1.expect)(index.isEmpty).to.exist;
        (0, chai_1.expect)(index.last).to.exist;
        (0, chai_1.expect)(index.map).to.exist;
        (0, chai_1.expect)(index.mapTo).to.exist;
        (0, chai_1.expect)(index.materialize).to.exist;
        (0, chai_1.expect)(index.max).to.exist;
        (0, chai_1.expect)(index.mergeAll).to.exist;
        (0, chai_1.expect)(index.flatMap).to.exist;
        (0, chai_1.expect)(index.mergeMap).to.exist;
        (0, chai_1.expect)(index.mergeMapTo).to.exist;
        (0, chai_1.expect)(index.mergeScan).to.exist;
        (0, chai_1.expect)(index.mergeWith).to.exist;
        (0, chai_1.expect)(index.min).to.exist;
        (0, chai_1.expect)(index.multicast).to.exist;
        (0, chai_1.expect)(index.observeOn).to.exist;
        (0, chai_1.expect)(index.pairwise).to.exist;
        (0, chai_1.expect)(index.pluck).to.exist;
        (0, chai_1.expect)(index.publish).to.exist;
        (0, chai_1.expect)(index.publishBehavior).to.exist;
        (0, chai_1.expect)(index.publishLast).to.exist;
        (0, chai_1.expect)(index.publishReplay).to.exist;
        (0, chai_1.expect)(index.raceWith).to.exist;
        (0, chai_1.expect)(index.reduce).to.exist;
        (0, chai_1.expect)(index.repeat).to.exist;
        (0, chai_1.expect)(index.repeatWhen).to.exist;
        (0, chai_1.expect)(index.retry).to.exist;
        (0, chai_1.expect)(index.retryWhen).to.exist;
        (0, chai_1.expect)(index.refCount).to.exist;
        (0, chai_1.expect)(index.sample).to.exist;
        (0, chai_1.expect)(index.sampleTime).to.exist;
        (0, chai_1.expect)(index.scan).to.exist;
        (0, chai_1.expect)(index.sequenceEqual).to.exist;
        (0, chai_1.expect)(index.share).to.exist;
        (0, chai_1.expect)(index.shareReplay).to.exist;
        (0, chai_1.expect)(index.single).to.exist;
        (0, chai_1.expect)(index.skip).to.exist;
        (0, chai_1.expect)(index.skipLast).to.exist;
        (0, chai_1.expect)(index.skipUntil).to.exist;
        (0, chai_1.expect)(index.skipWhile).to.exist;
        (0, chai_1.expect)(index.startWith).to.exist;
        (0, chai_1.expect)(index.subscribeOn).to.exist;
        (0, chai_1.expect)(index.switchAll).to.exist;
        (0, chai_1.expect)(index.switchMap).to.exist;
        (0, chai_1.expect)(index.switchMapTo).to.exist;
        (0, chai_1.expect)(index.switchScan).to.exist;
        (0, chai_1.expect)(index.take).to.exist;
        (0, chai_1.expect)(index.takeLast).to.exist;
        (0, chai_1.expect)(index.takeUntil).to.exist;
        (0, chai_1.expect)(index.takeWhile).to.exist;
        (0, chai_1.expect)(index.tap).to.exist;
        (0, chai_1.expect)(index.throttle).to.exist;
        (0, chai_1.expect)(index.throttleTime).to.exist;
        (0, chai_1.expect)(index.throwIfEmpty).to.exist;
        (0, chai_1.expect)(index.timeInterval).to.exist;
        (0, chai_1.expect)(index.timeout).to.exist;
        (0, chai_1.expect)(index.timeoutWith).to.exist;
        (0, chai_1.expect)(index.timestamp).to.exist;
        (0, chai_1.expect)(index.toArray).to.exist;
        (0, chai_1.expect)(index.window).to.exist;
        (0, chai_1.expect)(index.windowCount).to.exist;
        (0, chai_1.expect)(index.windowTime).to.exist;
        (0, chai_1.expect)(index.windowToggle).to.exist;
        (0, chai_1.expect)(index.windowWhen).to.exist;
        (0, chai_1.expect)(index.withLatestFrom).to.exist;
        (0, chai_1.expect)(index.zipAll).to.exist;
        (0, chai_1.expect)(index.zipWith).to.exist;
    });
    it('should expose configuration', function () {
        (0, chai_1.expect)(index.config).to.exist;
    });
});
//# sourceMappingURL=index-spec.js.map