"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var rxjs_1 = require("rxjs");
describe('Observable.toPromise', function () {
    it('should convert an Observable to a promise of its last value', function (done) {
        (0, rxjs_1.of)(1, 2, 3)
            .toPromise(Promise)
            .then(function (x) {
            (0, chai_1.expect)(x).to.equal(3);
            done();
        });
    });
    it('should convert an empty Observable to a promise of undefined', function (done) {
        rxjs_1.EMPTY.toPromise(Promise).then(function (x) {
            (0, chai_1.expect)(x).to.be.undefined;
            done();
        });
    });
    it('should handle errors properly', function (done) {
        (0, rxjs_1.throwError)(function () { return 'bad'; })
            .toPromise(Promise)
            .then(function () {
            done(new Error('should not be called'));
        }, function (err) {
            (0, chai_1.expect)(err).to.equal('bad');
            done();
        });
    });
    it('should allow for global config via config.Promise', function () { return __awaiter(void 0, void 0, void 0, function () {
        var wasCalled_1, x;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, , 2, 3]);
                    wasCalled_1 = false;
                    rxjs_1.config.Promise = function MyPromise(callback) {
                        wasCalled_1 = true;
                        return new Promise(callback);
                    };
                    return [4, (0, rxjs_1.of)(42).toPromise()];
                case 1:
                    x = _a.sent();
                    (0, chai_1.expect)(wasCalled_1).to.be.true;
                    (0, chai_1.expect)(x).to.equal(42);
                    return [3, 3];
                case 2:
                    rxjs_1.config.Promise = undefined;
                    return [7];
                case 3: return [2];
            }
        });
    }); });
});
//# sourceMappingURL=toPromise-spec.js.map