"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var createErrorClass_1 = require("rxjs/internal/util/createErrorClass");
var chai_1 = require("chai");
describe('createErrorClass', function () {
    it('should create a class that subclasses error and has the right properties', function () {
        var MySpecialError = (0, createErrorClass_1.createErrorClass)(function (_super) {
            return function MySpecialError(arg1, arg2) {
                _super(this);
                this.message = 'Super special error!';
                this.arg1 = arg1;
                this.arg2 = arg2;
            };
        });
        (0, chai_1.expect)(MySpecialError).to.be.a('function');
        var err = new MySpecialError(123, 'Test');
        (0, chai_1.expect)(err).to.be.an.instanceOf(Error);
        (0, chai_1.expect)(err).to.be.an.instanceOf(MySpecialError);
        (0, chai_1.expect)(err.constructor).to.equal(MySpecialError);
        (0, chai_1.expect)(err.stack).to.be.a('string');
        (0, chai_1.expect)(err.message).to.equal('Super special error!');
        (0, chai_1.expect)(err.arg1).to.equal(123);
        (0, chai_1.expect)(err.arg2).to.equal('Test');
    });
});
//# sourceMappingURL=createErrorClass-spec.js.map