"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var chai_1 = require("chai");
var isPromise_1 = require("rxjs/internal/util/isPromise");
describe('isPromise', function () {
    it('should return true for new Promise', function () {
        var o = new Promise(function () { return null; });
        (0, chai_1.expect)((0, isPromise_1.isPromise)(o)).to.be.true;
    });
    it('should return true for a Promise that comes from an Observable', function () {
        var o = (0, rxjs_1.of)(null).toPromise();
        (0, chai_1.expect)((0, isPromise_1.isPromise)(o)).to.be.true;
    });
    it('should NOT return true for any Observable', function () {
        var o = (0, rxjs_1.of)(null);
        (0, chai_1.expect)((0, isPromise_1.isPromise)(o)).to.be.false;
    });
    it('should return false for null', function () {
        (0, chai_1.expect)((0, isPromise_1.isPromise)(null)).to.be.false;
    });
    it('should return false for undefined', function () {
        (0, chai_1.expect)((0, isPromise_1.isPromise)(undefined)).to.be.false;
    });
    it('should return false for a number', function () {
        (0, chai_1.expect)((0, isPromise_1.isPromise)(1)).to.be.false;
    });
    it('should return false for a string', function () {
        (0, chai_1.expect)((0, isPromise_1.isPromise)('1')).to.be.false;
    });
});
//# sourceMappingURL=isPromise-spec.js.map